import { system, world, ItemComponentTypes, ItemStack } from "@minecraft/server";

const beestId = [
    'beest:tin_axe',
    'beest:tin_sword',
    'beest:tin_shovel',
    'beest:tin_pickaxe',
    'beest:tin_hoe'
];

world.afterEvents.itemCompleteUse.subscribe(({ source, itemStack }) => {
    const item = itemStack;

    if (!item) return;

    if (item.typeId === "beest:arowana") {
        source.addEffect('fire_resistance', 1800, { amplifier: 1 });
    }

    if (item.typeId === "beest:golden_largemouth_bass") {
        source.addEffect('regeneration', 400, { amplifier: 2 });
    }

    if (item.typeId === "beest:atlantic_mackerel") {
        source.addEffect('strength', 1200, { amplifier: 2 });
    }

    if (item.typeId === "beest:blobfish") {
        source.addEffect('nausea', 200, { amplifier: 5 });
    }

    if (item.typeId === "beest:electric_eel") {
        source.addEffect('speed', 200, { amplifier: 6 });
    }

    if (item.typeId === "beest:flying_fish") {
        source.addEffect('slow_falling', 1200, { amplifier: 2 });
    }

    if (item.typeId === "beest:glowfish") {
        source.addEffect('night_vision', 1800, { amplifier: 1 });
    }

    if (item.typeId === "beest:goldfish") {
        source.addEffect('absorption', 400, { amplifier: 2 });
    }

    if (item.typeId === "beest:guppy") {
        source.addEffect('water_breathing', 2400, { amplifier: 2 });
    }

    if (item.typeId === "beest:heartfish") {
        source.addEffect('instant_health', 20, { amplifier: 5 });
    }

    if (item.typeId === "beest:invisifish") {
        source.addEffect('invisibility', 600, { amplifier: 1 });
    }

    if (item.typeId === "beest:piranha") {
        source.addEffect('instant_damage', 20, { amplifier: 5 });
    }

    if (item.typeId === "beest:red_snapper") {
        source.addEffect('regeneration', 400, { amplifier: 2 });
    }

    if (item.typeId === "beest:sailsfish") {
        source.addEffect('haste', 1200, { amplifier: 2 });
    }

    if (item.typeId === "beest:cooked_sailsfish") {
        source.addEffect('haste', 1500, { amplifier: 2 });
    }

    if (item.typeId === "beest:squid") {
        source.addEffect('blindness', 300, { amplifier: 9 });
    }

    if (item.typeId === "beest:sunfish") {
        source.addEffect('slowness', 900, { amplifier: 2 });
    }

    if (item.typeId === "beest:tadpole") {
        source.addEffect('hunger', 400, { amplifier: 3 });
    }

    if (item.typeId === "beest:zebra_fish") {
        source.addEffect('resistance', 600, { amplifier: 2 });
    }
});


world.afterEvents.playerBreakBlock.subscribe(({ itemStackBeforeBreak: itemUsed, player }) => {

    if (!itemUsed) return;

    if (beestId.includes(itemUsed.typeId)) {
        const playerEquippableComp = player.getComponent("equippable");

        if (!playerEquippableComp) return;

        const durability = itemUsed.getComponent("durability");

        if (!durability) return;

        let durabilityModifier = 0;

        if (beestId.includes(itemUsed.typeId)) {

            durabilityModifier = 1;
        } else {
            durabilityModifier = 2;
        }

        const itemEnchantmentComp = itemUsed.getComponent("minecraft:enchantable");

        const unbreakingLevel = itemEnchantmentComp?.getEnchantment("unbreaking")?.level ?? 0;

        const breakChance = 100 / (unbreakingLevel + 1);
        const randomizeChance = Math.random() * 100;

        if (breakChance < randomizeChance) return;

        durability.damage += durabilityModifier;

        const maxDurability = durability.maxDurability

        const damage = durability.damage

        if (damage >= maxDurability) {

            player.playSound('random.break', { pitch: 1, location: player.location, volume: 1 })
            playerEquippableComp.setEquipment("Mainhand", new ItemStack('minecraft:air', 1));
        }
        else if (damage < maxDurability) {
            playerEquippableComp.setEquipment("Mainhand", itemUsed);
        }
    }
});

world.afterEvents.playerInteractWithEntity.subscribe(({ itemStack, player }) => {

    if (beestId.includes(itemStack.typeId)) {
        const playerEquippableComp = player.getComponent("equippable");

        if (!playerEquippableComp) return;

        const durability = itemstack.getComponent("durability");

        if (!durability) return;

        let durabilityModifier = 0;

        if (beestId.includes(itemStack.typeId)) {

            durabilityModifier = 1;
        } else {
            durabilityModifier = 2;
        }

        durability.damage += durabilityModifier;

        const maxDurability = durability.maxDurability

        const damage = durability.damage

        if (damage >= maxDurability) {

            player.playSound('random.break', { pitch: 1, location: player.location, volume: 1 })
            playerEquippableComp.setEquipment("Mainhand", new ItemStack('minecraft:air', 1));
        }
        else if (damage < maxDurability) {
            playerEquippableComp.setEquipment("Mainhand", itemUsed);
        }
    }
});